#include "s_socket.h"


/* functions */

EIF_INTEGER posix_bind (EIF_INTEGER socket, EIF_POINTER address, EIF_INTEGER addr_len)
{
  return bind (socket, (struct sockaddr *) address, addr_len);
}

EIF_INTEGER posix_connect (EIF_INTEGER socket, EIF_POINTER address, EIF_INTEGER addr_len)
{
  return connect (socket, (struct sockaddr *) address, addr_len);
}

EIF_INTEGER posix_listen(EIF_INTEGER socket, EIF_INTEGER backlog)
{
  return listen (socket, backlog);
}

EIF_INTEGER posix_socket (EIF_INTEGER family, EIF_INTEGER type, EIF_INTEGER protocol)
{
  return socket (family, type, protocol);
}


/* struct sockaddr */

EIF_INTEGER posix_sockaddr_size()
{
   return (sizeof (struct sockaddr));
}

EIF_INTEGER posix_sockaddr_sa_family(struct sockaddr *p)
{
  return p->sa_family;
}

EIF_POINTER posix_sockaddr_sa_data(struct sockaddr *p)
{
  return (EIF_POINTER) &(p->sa_data);
}


void posix_set_sockaddr_sa_family(struct sockaddr *p, EIF_INTEGER sa_family)
{
  p->sa_family = sa_family;
}


/* constants */

EIF_INTEGER const_sock_dgram()
{
  return SOCK_DGRAM;
}

EIF_INTEGER const_sock_packet()
{
#ifdef SOCK_PACKET
  return SOCK_PACKET;
#else
  return -1;
#endif
}


EIF_INTEGER const_sock_raw()
{
#ifdef SOCK_RAW
  return SOCK_RAW;
#else
  return -1;
#endif
}

EIF_INTEGER const_sock_seqpacket()
{
#ifdef SOCK_SEQPACKET
  return SOCK_SEQPACKET;
#else
  return -1;
#endif
}

EIF_INTEGER const_sock_stream()
{
  return SOCK_STREAM;
}



/* protocol families */

EIF_INTEGER const_af_inet()
{
  return AF_INET;
}
