indexing

	description: "Converts strings to pointers and vice versa."
	thanks: "The mico/E team for the idea."

	date: "$Date: 2003/01/09 $"
	revision: "$Revision: #3 $"

class

	EPX_STRING_HELPER


inherit

	ABSTRACT_STRING_HELPER


feature -- SmallEiffel specific conversions

	string_to_pointer (s: STRING): POINTER is
		do
			if s = Void then
				Result := default_pointer
			else
				Result := s.to_external
			end
		end

	pointer_to_string (p: POINTER): STRING is
			-- Returns a new string.
		do
			if p = default_pointer then
				create Result.make (0)
			else
				create Result.from_external_copy (p)
			end
		end

	set_string_from_pointer (s: STRING; p: POINTER) is
			-- copies contents of p to s
		do
			if p = default_pointer then
				s.clear
			else
				s.from_external_copy (p)
			end
		end


feature -- String utilities that have different names per compiler...

	make_with_capacity (capacity: INTEGER): STRING is
			-- Create a new string.
		do
			create Result.make (capacity)
		end


end
